export declare abstract class AbstractCacheAdapter {
    protected constructor();
    abstract isPersistent(): boolean;
    abstract flush(): Promise<void>;
    abstract setCache<T extends any>(key: string, value: T, expireAfter?: number): Promise<void>;
    abstract getCache<T>(key: string): Promise<T>;
}
//# sourceMappingURL=AbstractCacheAdapter.d.ts.map