import { AbstractHttpMiddleware } from "./AbstractHttpMiddleware";
import { AbstractHttpResponder } from "./AbstractHttpResponder";
import { PermissionType, HTTP, AbstractAccessCondition } from "../..";
export declare class HttpHandlerMetadata {
    url?: string;
    method?: HTTP;
    handlerFn: string;
    middleware?: AbstractHttpMiddleware[];
    queryValidator?: any;
    paramsValidator?: any;
    bodyValidator?: any;
    responder?: AbstractHttpResponder;
    openAccess?: boolean;
    noAccess?: boolean;
    override?: boolean;
    permissionName?: string;
    permissionGroup?: string;
    permissionType?: PermissionType;
    permissionConditions?: AbstractAccessCondition<any>[];
    allowOAuth?: boolean;
}
//# sourceMappingURL=HttpHandlerMetadata.d.ts.map