import { AbstractAccessCondition, ConditionPrototype } from "../security/AbstractAccessCondition";
import { HttpRequest } from "../controller/http/HttpRequest";
import { AbstractDatabaseAdapter } from "../database/AbstractDatabaseAdapter";
import { AbstractModel } from "../model/AbstractModel";
export declare class OwnedResource extends AbstractAccessCondition<boolean> {
    constructor(requestedValueResolver: (request: HttpRequest, databaseAdapter: AbstractDatabaseAdapter) => Promise<boolean>);
    getConditionPrototype(): ConditionPrototype;
    validate(requestedValue: boolean, permittedValue: boolean): Promise<boolean>;
}
export declare class FilterModelInfo extends AbstractAccessCondition<string[]> {
    private readonly valueConstraint;
    private readonly operator;
    constructor(model: new (args: any[]) => AbstractModel, operator: string, requestedValueResolver: (request: HttpRequest) => Promise<string[]>);
    getConditionPrototype(): ConditionPrototype;
    validate(requestedValue: string[], permittedValue: string[]): Promise<boolean>;
}
//# sourceMappingURL=DefaultAccessConditions.d.ts.map