import { AbstractCacheAdapter } from "../cache/AbstractCacheAdapter";
export declare class DefaultRedisCacheAdapter extends AbstractCacheAdapter {
    private readonly serverUrl;
    private readonly namespace;
    private redisClient;
    constructor(serverUrl: string, namespace: string);
    isPersistent(): boolean;
    init(): Promise<void>;
    setCache<T extends any>(key: string, value: T, expireAfterSecond?: number): Promise<void>;
    getCache<T extends any>(key: string): Promise<T>;
    flush(): Promise<void>;
}
//# sourceMappingURL=DefaultRedisCacheAdapter.d.ts.map