import { Injectee } from "../system/Injectee";
export declare abstract class AbstractEnvProvider implements Injectee {
    currentEnv: string;
    envFilePath?: string;
    fileNameResolver?: (currentEnv: string) => string;
    protected envVariables: {
        [envVarName: string]: any;
    };
    load<T>(template: {
        new (...args: any[]): T;
    }): T;
}
//# sourceMappingURL=AbstractEnvProvider.d.ts.map