import { LogLevel } from "../enum/LogLevel";
import { Injectee } from "../system/Injectee";
export declare abstract class AbstractLogger implements Injectee {
    protected level: LogLevel;
    logLevel: LogLevel;
    abstract debug(...logContent: any[]): void;
    abstract error(...logContent: any[]): void;
    abstract info(...logContent: any[]): void;
    abstract warn(...logContent: any[]): void;
}
//# sourceMappingURL=AbstractLogger.d.ts.map