import { AbstractEnvProvider } from "./environment/AbstractEnvProvider";
import { AbstractLogger } from "./logger/AbstractLogger";
import { AbstractHttpRequestHandler } from "./controller/http/AbstractHttpRequestHandler";
import { AbstractSocketRequestHandler } from "./controller/socket/AbstractSocketRequestHandler";
import { AbstractDataValidator } from "./validator/AbstractDataValidator";
import { AbstractDatabaseAdapter } from "./database/AbstractDatabaseAdapter";
import { Initable } from "./system/Initable";
export declare class Claire {
    private _envProvider;
    private _logger;
    private _socketRequestHandler;
    private _httpRequestHandler;
    private _databaseAdapter;
    private _dataValidator;
    port: number;
    bootstrap: Initable;
    constructor();
    envProvider: AbstractEnvProvider;
    logger: AbstractLogger;
    socketRequestHandler: AbstractSocketRequestHandler;
    httpRequestHandler: AbstractHttpRequestHandler;
    dataValidator: AbstractDataValidator;
    databaseAdapter: AbstractDatabaseAdapter;
    private stop;
    start(): Promise<unknown>;
}
//# sourceMappingURL=Claire.d.ts.map