import { HttpRequest } from "./HttpRequest";
import { HttpHandlerMetadata } from "./HttpHandlerMetadata";
import { Initable } from "../../system/Initable";
export declare abstract class AbstractHttpAuthorizationProvider implements Initable {
    abstract authorize(request: HttpRequest, handler: HttpHandlerMetadata): Promise<void>;
    init(): Promise<void>;
    stop(): Promise<void>;
}
//# sourceMappingURL=AbstractHttpAuthorizationProvider.d.ts.map