import { AbstractHttpMiddleware } from "./AbstractHttpMiddleware";
import { AbstractHttpController } from "./AbstractHttpController";
import { AbstractRequestHandler } from "../AbstractRequestHandler";
import { AbstractHttpErrorHandler } from "./AbstractHttpErrorHandler";
import { AbstractHttpAuthorizationProvider } from "./AbstractHttpAuthorizationProvider";
export declare abstract class AbstractHttpRequestHandler extends AbstractRequestHandler {
    private _controllers;
    mountPoint: string;
    middleware: AbstractHttpMiddleware[];
    assertValid(): void;
    readonly controllers: AbstractHttpController[];
    errorHandler: AbstractHttpErrorHandler;
    authorizationProvider?: AbstractHttpAuthorizationProvider;
}
//# sourceMappingURL=AbstractHttpRequestHandler.d.ts.map