import { AbstractCacheAdapter } from "../cache/AbstractCacheAdapter";
export declare class DefaultInMemoryCacheAdapter extends AbstractCacheAdapter {
    private hashmap;
    private countdownArray;
    constructor();
    isPersistent(): boolean;
    getCache<T extends any>(key: string): Promise<T>;
    setCache<T extends any>(key: string, value: T, expireAfterSecond?: number): Promise<void>;
    flush(): Promise<void>;
}
//# sourceMappingURL=DefaultInMemoryCacheAdapter.d.ts.map