export declare enum DataType {
    /**
     * Boolean value.
     */
    BOOL = "Boolean",
    /**
     * Numerical integer value.
     */
    INTEGER = "Integer",
    /**
     * Numerical floating point value.
     */
    FLOAT = "Float",
    /**
     * String value.
     */
    STRING = "String",
    /**
     * Text is to support string with unbounded length in MySQL.
     */
    TEXT = "Text",
    /**
     * Array of any type.
     */
    ARRAY = "Array",
    /**
     * 64 bit integer
     */
    BIGINT = "Bigint"
}
//# sourceMappingURL=DataType.d.ts.map